/*  lircrc-config pretends to be a GUI for LIRC's rc files.
    Copyright (C) 2001 Manuel Estrada Sainz <ranty@atdot.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <gnome.h>
#include <glade/glade.h>
#include "widget-groups.h"

static 
struct view_items{
	char *name;
	enum widget_groups group;
} items [] = {
	{"view_complete", VIEW_COMPLETE},
	{NULL, 0}
};

#warning FIXME: this sucks
static
char *view_complete_group[] ={
	"config_scrolledwindow",
	"config_buttons_hbox",
	"button_scrolledwindow",
	"button_buttons_hbox",
	NULL,
};
static
char **widget_groups[VIEW_GROUPS_TOTAL] = {
	view_complete_group,
};

void widget_group_manage(GtkCheckMenuItem *item, GladeXML *xml)
{
	int group = GPOINTER_TO_INT(gtk_object_get_data(GTK_OBJECT(item),
							"widget_group"));
	GtkWidget *editor_vbox=NULL;
	char **widget_name = widget_groups[group];

	g_return_if_fail(GLADE_IS_XML(xml));

	for(; *widget_name != NULL; widget_name++){
		GtkWidget *wid = glade_xml_get_widget(xml, *widget_name);
		g_return_if_fail(wid != NULL);
		if(item->active)
			gtk_widget_show_all(GTK_WIDGET(wid));
		else
			gtk_widget_hide_all(GTK_WIDGET(wid));
	}
	/* tidy the editor */
	editor_vbox=glade_xml_get_widget(xml, "main_vpaned");
	gtk_widget_hide(GTK_WIDGET(editor_vbox));
	gtk_widget_show(GTK_WIDGET(editor_vbox));
	
}
void notebook_comments_manage(GtkCheckMenuItem *item, GladeXML *xml)
{
	GtkNotebook *notebook;
	GtkWidget *editor_vbox;
	g_return_if_fail(GLADE_IS_XML(xml));

	notebook = GTK_NOTEBOOK(glade_xml_get_widget(xml, "notebook"));

	g_return_if_fail(notebook != NULL);

	if(item->active) {
		gtk_notebook_set_show_tabs (notebook, TRUE);
	}else{
		gtk_notebook_set_show_tabs (notebook, FALSE);
		gtk_notebook_set_page (notebook, 0);
	}

	/* tidy the editor */
	editor_vbox=glade_xml_get_widget(xml, "main_vpaned");
	gtk_widget_hide(GTK_WIDGET(editor_vbox));
	gtk_widget_show(GTK_WIDGET(editor_vbox));
}
void widget_group_setup(GladeXML *xml)
{
	struct view_items *item = items;
	GtkWidget *wid;
	int i=0;
	
	for(; item[i].name != NULL; i++){
		wid = glade_xml_get_widget(xml, item[i].name);
		gtk_signal_connect(GTK_OBJECT(wid),
				   "activate",
				   widget_group_manage,
				   xml);
		gtk_object_set_data(GTK_OBJECT(wid),
				    "widget_group",
				    GINT_TO_POINTER(item[i].group));
		widget_group_manage(GTK_CHECK_MENU_ITEM(wid), xml);
	}
	wid = glade_xml_get_widget(xml, "view_text_editor");
	gtk_signal_connect(GTK_OBJECT(wid),
			   "activate",
			   notebook_comments_manage,
			   xml);
	notebook_comments_manage(GTK_CHECK_MENU_ITEM(wid), xml);
}




